from molten import Environ, Include, Route
from typing import Dict


def welcome() -> Dict:
    return {"message": "welcome to databag"}


def echo(environ: Environ) -> Dict:
    return {k: str(v) for k, v in environ.items()}


echo_routes = Include(
    "/echo",
    [
        Route("", echo, method="GET", name="echo_get"),
        Route("", echo, method="POST", name="echo_post"),
        Route("", echo, method="PUT", name="echo_put"),
        Route("", echo, method="PATCH", name="echo_patch"),
        Route("", echo, method="DELETE", name="echo_delete"),
        Route("", echo, method="OPTIONS", name="echo_options"),
    ],
)
